//
//  Cross Track for Java
//  (c)1997 May 17 Programmed by Bv.
//

import java.applet.*;
import java.lang.*;
import java.awt.*;
import java.io.*;

public class CrossTrack extends Applet
  {
  Blocks blocks;
  Screen screen;
  Button new_button;
  Button cont_button;
  int flag;
  
  public void init()
    {
    blocks = new Blocks();
    screen = new Screen(blocks);
    new_button = new Button("NEW");
    cont_button = new Button("CONTINUE");
    new_button.disable();
    cont_button.disable();
    setLayout(new BorderLayout());
    Panel panel = new Panel();
    panel.add(new_button);
    panel.add(cont_button);
    add("Center", screen);
    add("South", panel);
    resize(256,288);
    show();
    }
  
  public void start()
    {
    int stagelevel = 1;
    while(true)
      {
      blocks.loadStage(stagelevel);
      screen.drawAll();
      waitContinue();
      Stage stage = new Stage(blocks, screen);
      stage.start();
      while(stage.isAlive())
	try{ Thread.sleep(10); }catch(InterruptedException e){}
      if(blocks.clear())
	{
	screen.drawComplete(stagelevel++);
	waitContinue();
	}
      else{
        screen.drawGameOver();
	blocks.clearScore();
	if(waitNew()) stagelevel = 1;
        }
      }
    }
  
  public synchronized boolean waitContinue()
    {
    cont_button.enable();
    flag = 0;
    while(flag == 0)
      try{ wait(); }catch(InterruptedException e){};
    cont_button.disable();
    if(flag == 1) return true;
    return false;
    }
  
  public synchronized boolean waitNew()
    {
    cont_button.enable();
    new_button.enable();
    flag = 0;
    while(flag == 0)
      try{ wait(); }catch(InterruptedException e){};
    cont_button.disable();
    new_button.disable();
    if(flag == 1) return false;
    return true;
    }
  
  public boolean action(Event evt, Object arg)
    {
    if(arg.equals("CONTINUE"))
      {
      synchronized(this){ flag=1; notify(); }
      return true;
      }
    else if(arg.equals("NEW"))
      {
      synchronized(this){ flag=2; notify(); }
      return true;
      }
    return super.action(evt, arg);
    }
  
  public boolean mouseDown(Event evt, int x, int y)
    {
    blocks.reflectX();
    return true;
    }
  
  public boolean keyDown(Event evt, int key)
    {
    if(evt.key == ' ')
      blocks.reflectX();
    return true;
    }
  }