//
//  Cross Track for Java
//  (c)1997 May 17 Programmed by Bv.
//

import java.applet.*;
import java.lang.*;
import java.awt.*;
import java.io.*;

public class CrossTrack extends Frame
  {
  Blocks blocks;
  Button cont_button;
  Button new_button;
  int flag;
  
  public static void main(String args[])
    {
    Blocks blocks = new Blocks();
    Screen screen = new Screen(blocks);
    CrossTrack game = new CrossTrack(blocks);
    game.add("Center", screen);
    game.show();
    
    int stagelevel = 1;
    while(true)
      {
      blocks.loadStage(stagelevel);
      screen.drawAll();
      game.waitContinue();
      Stage stage = new Stage(blocks, screen);
      stage.start();
      while(stage.isAlive())
	try{ Thread.sleep(10); }catch(InterruptedException e){}
      if(blocks.clear())
	{
	screen.drawComplete(stagelevel++);
	game.waitContinue();
	}
      else{
	screen.drawGameOver();
	blocks.clearScore();
	if(game.waitNew()) stagelevel = 1;
	}
      }
    }
  
  public CrossTrack(Blocks blocks)
    {
    super("Cross Track");
    Panel panel = new Panel();
    new_button = new Button("NEW");
    cont_button = new Button("CONTINUE");
    new_button.disable();
    cont_button.disable();
    panel.add(new_button);
    panel.add(cont_button);
    add("South", panel);
    resize(256,288);
    setResizable(false);
    this.blocks = blocks;
    }
  
  public synchronized boolean waitContinue()
    {
    cont_button.enable();
    flag = 0;
    while(flag == 0)
      try{ wait(); }catch(InterruptedException e){};
    cont_button.disable();
    if(flag == 1) return true;
    return false;
    }
  
  public synchronized boolean waitNew()
    {
    cont_button.enable();
    new_button.enable();
    flag = 0;
    while(flag == 0)
      try{ wait(); }catch(InterruptedException e){};
    cont_button.disable();
    new_button.disable();
    if(flag == 1) return false;
    return true;
    }
  
  public boolean action(Event evt, Object arg)
    {
    if(arg.equals("CONTINUE"))
      {
      synchronized(this){ flag=1; notify(); }
      return true;
      }
    else if(arg.equals("NEW"))
      {
      synchronized(this){ flag=2; notify(); }
      return true;
      }
    return super.action(evt, arg);
    }
  
  public boolean mouseDown(Event evt, int x, int y)
    {
    blocks.reflectX();
    return true;
    }
  
  public boolean keyDown(Event evt, int key)
    {
    if(evt.key == ' ')
      blocks.reflectX();
    return true;
    }
  
  public boolean handleEvent(Event evt)
    {
    if(evt.id == Event.WINDOW_DESTROY)
      System.exit(0);
    return super.handleEvent(evt);
    }
  }